{*****************************************************************************
  Copyright: Copyright by yu wei, 2001 - 2002
  Unit Name:    KWizard
  Author:       yu wei
  Email:        william_yuwei@yahoo.com
  Date:         December 30, 2001
  Last Updated: Janrary 21, 2002
  Time:         15:59:46
  Purpose:      Wizard VCL component

  IMPORTANT: This is a freeware components, so you can use them any way.
             Please note that the component and software are provided "AS-IS"
             without warranty.

  LICENCE AGREEMENT :

   THIS COMPONENT IS FREEWARE. IT IS FREE FOR COMMERICAL OR NON-COMMERICAL
   USE. BEFORE PROCEEDING WITH THE INSTALLATION AND/OR USE OF THIS
   COMPONENT, CAREFULLY READ THE FOLLOWING TERMS AND CONDITIONS OF THIS
   LICENSE AGREEMENT.

     BY INSTALLING OR USING THE COMPONENT YOU INDICATE YOUR ACCEPTANCE
     OF THIS AGREEMENT. IF YOU DO NOT ACCEPT OR AGREE WITH THESE TERMS,
     YOU MAY NOT INSTALL OR USE IT!

     DISTRIBUTION RIGHTS:

     YOU ARE GRANTED A NON-EXCISIVE, ROYALTY-FREE RIGHT TO PRODUCE AND
     DISTRIBUTE COMPILED BINARY FILES (EXE, DLLs, ETC.) THAT ARE BUILT
     WITH THIS COMPONENT. YOU ARE FURTHER GRANTED PERMISSION TO REDISTRIBUTE
     ANY OF MY SOURCE CODES, PROVIDED THAT THE ORIGINAL ARCHIVE AS FOUND
     ON MY WEB SITE IS DISTRIBUTED UNMODIFIED. FOR EXAMPLE, IF YOU CREATE A
     DESCENDANT OF THIS COMPONENET YOU MUST INCLUDE IN THE ORIGINAL
     COMPONENT IN YOUR DISTRIBUTION PACKAGE.

     RESTRICTIONS:

     WITHOUT THE EXPRESS WRITTEN CONSENT OF THE AUTHOR, YOU CANNOT:

     DISTRIBUTE MODIFIED VERSIONS OF MY SOURCES CODES.  YOU MUST
     INCLUDE THE ORIGINAL ARCHIVE AS YOU FOUND IT AT MY WEB SITE.
     SELL OR LEASE ANY PORTION OF THIS SOURCE CODE.
     YOU ARE, OF COURSE FREE TO SELL ANY OF YOUR OWN ORIGINAL CODE
     THAT WORKS WITH, ENHANCES WITH IT. DISTRIBUTE THIS SOURCE CODE
     FOR PROFIT.

     WARRANTY:

     THIS SOFTWARE IS PROVIDED "AS-IS" WITHOUT WARRANTY.
     THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PRODUCT IS
     YOURS. SHOULD THE PRODUCT PROVE DEFECTIVE,  YOU ASSUME THE COST OF ALL
     NECESSARY SERVICING OR ERROR CORRECTION. THE AUTHOR DON'T WARRANT THAT
     THE FUNCTIONS CONTAINED IN COMPONENT WILL MEET YOUR REQUIREMENTS OR
     THAT OPERATION OF THE SOFTWARE WILL BE UNINTERRUPTED OR ERROR FREE.

  SUGGESTIONS, COMMENTS AND BUGS:

     Any suggestion, comment or bugs, please send to
       william_yuwei@yahoo.com

  Contributors:

    Steve Forbes          <ozmosys@mira.net>
    Wayne Niddery
    Chris Macksey
    Raymond J. Schappe

  History:
  ---------------------------------------------------------------------------
  Date(mm/dd/yy)   Comments
  ---------------------------------------------------------------------------
  01/31/2002       1) Improved the RepositionButtons method of TKWizard,
                      so all the buttons can be positioned properly regardless
                      how their neighbors are.
                   2) CM_VisibleChanged message handler added for
                      TKWizardButtonControl, so when the button is visible or
                      invisible, it can make the rest buttons in proper
                      position.

  01/30/2002       1) Rename the methods of TKWizardRouteMapControl
                   2) WizardPageMoved method added for TKWizardRouteMapControl
                      which fired after the order of the page changed.
                   3) OnPaintPage event added for TKWizardCustomPage, so
                      the developers can custom draw the page.
                   4) A TKWizardCustomPage parameter added for IsFirstPage,
                      IsLastPage of TKWizard to test if the specific page is
                      the first page or the last page.
                   5) Buttons property added for TKWizardCustomPage, it can
                      easily access all navigation buttons of TKWizard.
                   6) Improved the process to handle the button visible
                      property in more efficent way.
                        see UpdateButtonControlsStatus method of TKWizard

  01/29/2002       1) Pages property added for TKWizard.
                   2) PageCount property added for TKWizard.
                   3) Page List Property Editor added for Pages property
                     of TKWizard. From this property editor, we can

                         a) Add new wizard pages.
                         b) Remove selected pages.
                         c) Drag drop selected page item to change pages' order.

  01/28/2002       1) Bug fixed: if the current active page set to disabled,
                                 the wizard would not go to next page.
                   2) Page screen flicker problem solved by setting
                      the DoubleBuffered property of TKWizardCustomPage
                      to True.
                   3) ParentFont property added for TKWizardPageHeader.

  01/27/2002       VERSION 1.5 BETA RELEASED

                   1) KWizard About form added by <Steve Forbes>
                        Thanks for his great job !!!!
                   2) Improve the design time button function, press Back
                      button at first page will forward to the last page. While
                      press Next button at last page will forward to the first
                      page. (See FindNextPage method in TKWizard)
                   3) Fixed AV when delete only one page in the wizard at
                      design time. (see RemovePage method in TKWizard)
                   4) NumGlyphs property added for TKWizardButton by
                      <Steve Forbes>, to solve the problem where the
                      NumGlyphs property of the actual button always reset
                      to 1 when it is created dynamically.
                   5) Layout property added for TKWizardButton.
                   6) Set ImageAlign property's default value of
                      TKWizardPageHeader to waRight.

  01/26/2002       1) Suggested by <Steve Forbes>:
                        Anchors, AnchorPlacement, Indent property added for
                        the text in TKWizardPageTitle. Remove Left, Top, Width,
                        Height properties from TKWizardPageTitle. so it is much
                        easiler to operate the title and subtitle.
                   2) Image property added for TKWizardCustomPage,
                      both Welcome page and Interior page can display a
                      background image.
                   3) Image property added for the TKWizardWaterMark.
                   4) ImageIndex, ImageAlign, ImageOffset property added for
                      TKWizardPageHeader. the PageHeader use ImageIndex
                      to retreive image from the header image list of TKWizard.

  01/25/2002       OFFICIAL RELEASE VERSION 1.2

                     Finally, KWizard has its offical icon!!! It is very cool!
                     Thanks <Steve Forbes> for his great job !!!!

                   1) Move OnEnterPage, OnPage, OnExitPage event from TKWizard
                      into TKWizardCustomPage.
                   2) TKWizardPagePanel added, suggested by <Steve Forbes>.
                   3) Glyph property added for TKWizardButton.
                   4) HeaderImages property added for TKWizard, it is an
                      image list, which stores all the page header images.

  01/24/2002       1) Rename TKWizardTitle to TKWizardPageTitle.
                   2) PaintTo method added for TKWizardWaterMark.
                      PaintTo method added for TKWizardPageHeader.
                      PainTo method added for TKWizardPageTitle.
                   3) Remove the DisplayPageHeader method from
                      TKWizardCustomPage.
                   4) OnPage event added for TKWizard, fired after the page
                      shows up.
                   5) Pages, PageCount, PageIndex property, and default code
                      added for all virtual method for TKWizardRouteMapControl.
                   6) Compiler directive added, suggested
                      by <Raymond J. Schappe>.
                   7) Handle Design time package and Run time package,
                      package file name convenstion suggested by
                      <Steve Forbes>:
                        Design time package: KWizardD?.dpk (bpl, dcp, ...)
                        Run time package: KWizardD?R.dbp (bpl, dcp, ...)
                      Here the ? = Delphi Version (5, 6, ..., etc)

  01/23/2002       1) Start Page, Last Page buttons added for TKWizard,
                       default they are invisible.
                   2) Visible property added for TKWizardButton.

  01/22/2002       BorderWidth property added for TKWizardWaterMark, suggested
                   by <Steve Forbes>

                   1) Remove the TKWizardButtonBar, now all the navigate
                      buttons are located in the Wizard. Hint:
                        Add overrided AdjustClientRect for TKWizard.
                   2) Bug fixed: Add csAcceptsControls control style into
                        TKWizard, otherwise it won't accept other controls
                        like KWizardRouteMap.
                   3) Bug fixed: TKWizard.GetChildren procedure, it won't
                        display another controls (include KWizardRouteMap
                        Control) even if the control is in the wizard.
                   4) Align property added for TKWizardRouteMap, so the
                      KWizardRouteMap can display at either left or right
                      side of the Wizard.
                   5) Align property added for TKWaterMark, so it can be
                      displayed at either left or right side of Welcome Page.

  01/21/2002       OFFICAL RELEASE VERSION 1.1

                   Suggested by <Chris Macksey>:
                   
                   1) Add OnNextPage, OnPriorPage, OnFirstPage, OnLastPage
                      events, so user can redirect the page try to go to.
                   2) Add OnEnterPage, triggled before the page shows up.
                      Add OnExitPage, triggled after the page is hidded.

  01/14/2002       1) Add ShowRouteMap property for the TKWizard.
                   2) Add destructor in the TKWizardRouteMap class to fix
                      AV when browse pages after destroy the TKWizardRouteMap
                      component.

  01/13/2002       Make the TKWizardRouteMap as a separat new component
                    so the user can design its own routemap and communicate
                    with TKWizard smoothly.

  01/12/2002       OFFICAL RELEASE VERSION 1.0

                   1) Thanks <Wayne Niddery> for his help to fix:
                        Under certain circumstance, the Wizard did not always
                        default to the first page. Add overrided
                        Loaded method in the TKWizard class.
                   2) Restructure: add TKWizardHeader and TKWizardWaterMark,
                      I hate to list all properites like: HeaderColor,
                      HeaderWidth, HeaderVisible, ... etc. Instead, I group
                      them together into particular class, and it can make
                      the whole component has a very clean property
                      structure.

  01/11/2002       1) Add word break feature when display title and subtitle.
                   2) At Design time, display page name in the wizard page.
                   3) Let the TWizardCustomPage paint and fill its area first
                      and let TWizardWelcomePage and TWizardInteriorPage
                      do the rest.

  01/10/2002       OFFICAL RELEASE BETA VERSION

                   1) Delete BackButton, NextButton, FinishButton, CancelButton
                      property, instead of a Button array.
                   2) Introduce TKWizardBackButton, TKWizardNextButton,
                      TKWizardFinishButton and TKWizardCancelButton Control
                   3) Add TKWizardTitle class, HeaderColor, HeaderHeight,
                      HeaderVisible property for TKWizardCustomPage.
                   4) Add WaterMarkColor, WaterMarkWidth, WaterMarkVisible
                      property for TKWizardWelcomePage.
                   5) Paint method of TKWizardWelcomPage improved,
                      TKWizardInteriorPage, so they can display header
                      as well as title and subtitle.

  01/06/2002       1) Add TKWizardRouteMap, Improve all existing functions
                        and class.
                   2) Add TKWizardCustomPage.

  01/05/2002       1) Add TKWizardButton class.
                   2) Add BackButton, NextButton, FinishButton,
                      CancelButton property for TKWizard.

  01/04/2002       1) Add ShowDivider property for TKWizard.
                   2) Add GetButtonClick, SetButtonClick for TKWizardButtonBar.
                   3) Draw divider in fsGroove frame style.

  12/30/2001       Initial create.

  To Do:

    Wizard page can be transparent

******************************************************************************}

unit KWizard;

interface

{$I KOMPONENTS.INC}

uses Windows, {$IFDEF DELPHI6}Types,{$ENDIF} Classes, Messages, SysUtils,
     Buttons, Controls, ExtCtrls, StdCtrls, Dialogs, Graphics, ImgList;

type
  TKWizardAboutInfo = (KWizardAbout);
  TKWizardAlign = (waLeft, waRight, waTop, waBottom);
  TKWizardLeftRightAlign = waLeft..waRight;
  EKWizard = class(Exception);
  TKWizardCustomPage = class;
  TKWizard = class;
  // YW - bkFinish should be prior than bkNext, so it can be created first.
  TKWizardButtonKind = (bkStart, bkLast, bkBack, bkFinish, bkNext, bkCancel);

  TKWizardButtonControl = class(TBitBtn)
  private
    FWizard: TKWizard;
    procedure CMVisibleChanged(var Msg: TMessage); message CM_VISIBLECHANGED;
    procedure CMDesignHitTest(var Msg: TCMDesignHitTest); message CM_DESIGNHITTEST;
  protected
    property Wizard: TKWizard
      read FWizard write FWizard;
  public
    constructor Create(AOwner: TComponent); override;
  end;

  // YW - First Button
  TKWizardStartButton = class(TKWizardButtonControl)
  public
    constructor Create(AOwner: TComponent); override;
    procedure Click; override;
  end;

  // YW - Last Button
  TKWizardLastButton = class(TKWizardButtonControl)
  public
    constructor Create(AOwner: TComponent); override;
    procedure Click; override;
  end;

  // YW - Back Button
  TKWizardBackButton = class(TKWizardButtonControl)
  public
    constructor Create(AOwner: TComponent); override;
    procedure Click; override;
  end;

  // YW - Next Button
  TKWizardNextButton = class(TKWizardButtonControl)
  public
    constructor Create(AOwner: TComponent); override;
    procedure Click; override;
  end;

  // YW - Finish Button
  TKWizardFinishButton = class(TKWizardButtonControl)
  public
    constructor Create(AOwner: TComponent); override;
    procedure Click; override;
  end;

  // YW - Cancel Button
  TKWizardCancelButton = class(TKWizardButtonControl)
  public
    constructor Create(AOwner: TComponent); override;
    procedure Click; override;
  end;

  TKWizardButtonControlClass = class of TKWizardButtonControl;

  // YW - The wrapper of the TKWizardButtonControl
  TKWizardButton = class(TPersistent)
  private
    FWizardButtonControl: TKWizardButtonControl;
    // YW - The key to visible or invisible a button,
    // if FVisible set to false, the button will never shows up even if
    // its visible property is set to true.
    FVisible: Boolean;
    procedure SetWizardButtonControl(const Value: TKWizardButtonControl);
    procedure SetEnabled(const Value: Boolean);
    function GetEnabled: Boolean;
    procedure SetCaption(const Value: string);
    function GetCaption: string;
    procedure SetVisible(const Value: Boolean);
    function GetGlyph: TBitmap;
    procedure SetGlyph(const Value: TBitmap);
    function GetNumGlyphs: Integer;
    procedure SetNumGlyphs(const Value: Integer);
    function GetLayout: TButtonLayout;
    procedure SetLayout(const Value: TButtonLayout);
  protected
    property WizardButtonControl: TKWizardButtonControl
      read FWizardButtonControl write SetWizardButtonControl;
  published
    property Glyph: TBitmap
      read GetGlyph write SetGlyph;
    property Enabled: Boolean
      read GetEnabled write SetEnabled;
    property Caption: string
      read GetCaption write SetCaption;
    property Visible: Boolean
      read FVisible write SetVisible;
    property NumGlyphs: Integer
      read GetNumGlyphs write SetNumGlyphs;
    property Layout: TButtonLayout
      read GetLayout write SetLayout;
  end;

  // YW - TKWizardRouteMap base class
  TKWizardRouteMapControl = class(TCustomControl)
  private
    FWizard: TKWizard;
    FAlign: TKWizardAlign;
    FPages: TList;
    FPageIndex: Integer;
    function GetPage(Index: Integer): TKWizardCustomPage;
    function GetPageCount: Integer;
    procedure SetAlign(Value: TKWizardAlign);
    procedure SetPageIndex(Value: Integer);
    procedure CMDesignHitTest(var Msg: TCMDesignHitTest); message CM_DESIGNHITTEST;
    procedure DoAddPage(const APage: TKWizardCustomPage);
    procedure DoDeletePage(const APage: TKWizardCustomPage);
    procedure DoUpdatePage(const APage: TKWizardCustomPage);
    procedure DoActivatePage(const APage: TKWizardCustomPage);
    procedure DoMovePage(const APage: TKWizardCustomPage; const OldIndex: Integer);
  protected
    procedure SetParent(AParent: TWinControl); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    function PageAtPos(Pos: TPoint): Integer; virtual;
    procedure WizardPageAdded(const APage: TKWizardCustomPage); virtual;
    procedure WizardPageDeleted(const APage: TKWizardCustomPage); virtual;
    procedure WizardPageUpdated(const APage: TKWizardCustomPage); virtual;
    procedure WizardPageActivated(const APage: TKWizardCustomPage); virtual;
    procedure WizardPageMoved(const APage: TKWizardCustomPage;
      const OldIndex: Integer); virtual;
    procedure SetActivePage(APage: TKWizardCustomPage);
    property Wizard: TKWizard
      read FWizard write FWizard;
    property Align: TKWizardAlign
      read FAlign write SetAlign
      default waLeft;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Pages[Index: Integer]: TKWizardCustomPage
      read GetPage;
    property PageCount: Integer read GetPageCount;
    property PageIndex: Integer
      read FPageIndex write SetPageIndex;
  end;

  // YW - Wizard Page Title class
  TKWizardPageTitle = class(TPersistent)
  private
    FText: string;
    FAlignment: TAlignment;
    FAnchorPlacement: Integer;
    FAnchors: TAnchors;
    FIndent: Integer;
    FFont: TFont;
    FOnChange: TNotifyEvent;
    procedure SetText(Value: string);
    procedure SetAlignment(Value: TAlignment);
    procedure SetAnchors(Value: TAnchors);
    procedure SetAnchorPlacement(Value: Integer);
    procedure SetIndent(Value: Integer);
    procedure SetFont(Value: TFont);
    procedure SetOnChange(Value: TNotifyEvent);
    procedure DoChange;
  protected
    // Get the area where the title text should be painted on.
    function GetTextRect(const ACanvas: TCanvas;
      const ARect: TRect): TRect; virtual;
    function PaintTo(ACanvas: TCanvas; ARect: TRect;
      ShowOutline: Boolean): Integer; virtual;
  public
    constructor Create;
    destructor Destroy; override;
    property OnChange: TNotifyEvent
      read FOnChange write SetOnChange;
  published
    property Text: string
      read FText write SetText;
    property Anchors: TAnchors
      read FAnchors write SetAnchors;
    property AnchorPlacement: Integer
      read FAnchorPlacement write SetAnchorPlacement;
    property Indent: Integer
      read FIndent write SetIndent;
    property Alignment: TAlignment
      read FAlignment write SetAlignment;
    property Font: TFont
      read FFont write SetFont;
  end;

  TKWizardPersistent = class(TPersistent)
  private
    FWizardPage: TKWizardCustomPage;
    FColor: TColor;
    FVisible: Boolean;
    procedure SetColor(Value: TColor);
    procedure SetVisible(Value: Boolean);
    procedure DoChange;
  protected
    procedure SetWizardPage(Value: TKWizardCustomPage); virtual;
    property WizardPage: TKWizardCustomPage
      read FWizardPage write SetWizardPage;
    property Color: TColor
      read FColor write SetColor;
    property Visible: Boolean
      read FVisible write SetVisible;
  public
    constructor Create;
  end;

  // YW - Wizard Page Header class
  TKWizardPageHeader = class(TKWizardPersistent)
  private
    FHeight: Integer;
    FParentFont: Boolean;
    FTitle: TKWizardPageTitle;
    FSubtitle: TKWizardPageTitle;
    FImageIndex: Integer;
    FImageOffset: Integer;
    FImageAlign: TKWizardLeftRightAlign;
    procedure SetHeight(Value: Integer);
    procedure SetImageIndex(Value: Integer);
    procedure SetImageOffset(Value: Integer);
    procedure SetImageAlign(Value: TKWizardLeftRightAlign);
    procedure SetParentFont(Value: Boolean);
    procedure ChangeFont; // change current font to wizard page's font
    procedure OnChange(Sender: TObject);
  protected
    procedure SetWizardPage(Value: TKWizardCustomPage); override;
    // the return value of ARect is the area where the title should be painted
    // on. The result of GetImageRect is the image area.
    function GetImageRect(const AImages: TCustomImageList;
      var ARect: TRect): TRect; virtual;
  public
    constructor Create;
    destructor Destroy; override;
    procedure PaintTo(ACanvas: TCanvas; var ARect: TRect;
      ShowHeaderDivider, ShowTitleOutline: Boolean); virtual;
  published
    property ImageIndex: Integer
      read FImageIndex write SetImageIndex;
    property ImageOffset: Integer
      read FImageOffset write SetImageOffset;
    property ImageAlign: TKWizardLeftRightAlign
      read FImageAlign write SetImageAlign;
    property Height: Integer
      read FHeight write SetHeight;
    property ParentFont: Boolean
      read FParentFont write SetParentFont;
    property Title: TKWizardPageTitle
      read FTitle write FTitle;
    property Subtitle: TKWizardPageTitle
      read FSubtitle write FSubtitle;
    property Color;
    property Visible;
  end;

  // YW - Welcome Page's watermark class
  TKWizardWaterMark = class(TKWizardPersistent)
  private
    FAlign: TKWizardLeftRightAlign;
    FWidth: Integer;
    FBorderWidth: Integer;
    FImage: TPicture;
    procedure SetWidth(Value: Integer);
    procedure SetBorderWidth(Value: Integer);
    procedure SetAlign(Value: TKWizardLeftRightAlign);
    procedure SetImage(Value: TPicture);
    procedure ImageChanged(Sender: TObject);
  protected
    procedure PaintTo(ACanvas: TCanvas; var ARect: TRect); virtual;
  public
    constructor Create;
    destructor Destroy; override;
  published
    property Align: TKWizardLeftRightAlign
      read FAlign write SetAlign;
    property BorderWidth: Integer
      read FBorderWidth write SetBorderWidth;
    property Image: TPicture
      read FImage write SetImage;
    property Width: Integer
      read FWidth write SetWidth;
    property Color;
    property Visible;
  end;

  // YW - Wizard Page Panel class used only by Interior Page
  TKWizardPagePanel = class(TKWizardPersistent)
  private
    FBorderWidth: Word;
    procedure SetBorderWidth(Value: Word);
  public
    constructor Create;
    procedure PaintTo(ACanvas: TCanvas; var ARect: TRect); virtual;
  published
    property BorderWidth: Word
      read FBorderWidth write SetBorderWidth;
    property Color;
    property Visible;
  end;

  TKWizardPaintPageEvent = procedure(Sender: TObject; ACanvas: TCanvas;
    var ARect: TRect) of object;

  // YW - Wizard Custom Page
  TKWizardCustomPage = class(TCustomControl)
  private
    FWizard: TKWizard;
    FHeader: TKWizardPageHeader;
    FPanel: TKWizardPagePanel;
    FDrawing: Boolean;
    FImage: TPicture;
    FOnPaintPage: TKWizardPaintPageEvent;
    FOnEnterPage: TNotifyEvent;
    FOnPage: TNotifyEvent;
    FOnExitPage: TNotifyEvent;
    function GetPageIndex: Integer;
    function GetButtons(Index: TKWizardButtonKind): TKWizardButton;
    procedure SetPageIndex(const Value: Integer);
    procedure SetImage(Value: TPicture);
    procedure SetWizard(AWizard: TKWizard);
    procedure ImageChanged(Sender: TObject);
    procedure WMEraseBkgnd(var Message: TWmEraseBkgnd); message WM_ERASEBKGND;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
    procedure CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
    procedure CMEnabledChanged(var Message: TMessage); message CM_ENABLEDCHANGED;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure ReadState(Reader: TReader); override;
    procedure Paint; override;
    // YW - PaintPage is called by paint method. all the derived page controls
    // should call this method to paint itsself rather than the overrided
    // paint method.
    procedure PaintPage(ACanvas: TCanvas; var ARect: TRect); virtual;
    procedure Enter; virtual; // YW - called before the page shows up.
    procedure Done; virtual; // YW - called after the page shows up.
    procedure Exit; virtual; // YW - called after the page is hidden.
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Wizard: TKWizard
      read FWizard write SetWizard;
    property PageIndex: Integer
      read GetPageIndex write SetPageIndex
      stored False;
    property Buttons[Index: TKWizardButtonKind]: TKWizardButton
      read GetButtons;
  published
    property Header: TKWizardPageHeader
      read FHeader write FHeader;
    property Image: TPicture
      read FImage write SetImage;
    property Panel: TKWizardPagePanel
      read FPanel write FPanel;
    property Color;
    property Caption;
    property Enabled;
    property Font;
    property Left stored False;
    property Height stored False;
    property PopupMenu;
    property ShowHint;
    property Top stored False;
    property Width stored False;
    property OnEnterPage: TNotifyEvent
      read FOnEnterPage write FOnEnterPage;
    property OnPage: TNotifyEvent
      read FOnPage write FOnPage;
    property OnExitPage: TNotifyEvent
      read FOnExitPage write FOnExitPage;
    property OnPaintPage: TKWizardPaintPageEvent
      read FOnPaintPage write FOnPaintPage;
  end;

  // YW - Wizard Welcome Page
  TKWizardWelcomePage = class(TKWizardCustomPage)
  private
    FWaterMark: TKWizardWaterMark;
  protected
    procedure PaintPage(ACanvas: TCanvas; var ARect: TRect); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property WaterMark: TKWizardWaterMark
      read FWaterMark write FWaterMark;
  end;

  TKWizardInteriorPage = class(TKWizardCustomPage)
  protected
    procedure PaintPage(ACanvas: TCanvas; var ARect: TRect); override;
  end;

  TKWizardChangePageEvent = procedure(Sender: TObject;
    FromPage: TKWizardCustomPage; var ToPage: TKWizardCustomPage) of object;

  // YW - KWizard Control
  TKWizard = class(TCustomControl)
  private
    FPages: TList;
    FActivePage: TKWizardCustomPage;
    FWizardRouteMapControl: TKWizardRouteMapControl;
    FButtonControls: array[TKWizardButtonKind] of TKWizardButtonControl;
    FWizardButtons: array[TKWizardButtonKind] of TKWizardButton;
    FShowDivider: Boolean;
    FOnNextPage: TKWizardChangePageEvent;
    FOnPriorPage: TKWizardChangePageEvent;
    FOnFirstPage: TKWizardChangePageEvent;
    FOnLastPage: TKWizardChangePageEvent;
    FHeaderImages: TCustomImageList;
    FImageChangeLink: TChangeLink;
    FAboutInfo: TKWizardAboutInfo;  // Add by Steve Forbes
    procedure SetShowDivider(Value: Boolean);
    function GetShowRouteMap: Boolean;
    procedure SetShowRouteMap(Value: Boolean);
    procedure SetActivePage(Page: TKWizardCustomPage);
    procedure SetHeaderImages(Value: TCustomImageList);
    function GetButtonClick(const Index: TKWizardButtonKind): TNotifyEvent;
    procedure SetButtonClick(const Index: TKWizardButtonKind;
      const Value: TNotifyEvent);
    procedure ImageListChange(Sender: TObject);
    procedure CreateNavigationButtons;
    procedure ChangeActivePage(Page: TKWizardCustomPage);
    function GetActivePageIndex: Integer;
    procedure SetActivePageIndex(Value: Integer);
    function GetPageCount: Integer;
    procedure RepositionButtons;
    procedure UpdateButtonControlsStatus;
    procedure WMEraseBkgnd(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
    procedure WMGetDlgCode(var Message: TWMGetDlgCode); message WM_GETDLGCODE;
    procedure CMDesignHitTest(var Message: TCMDesignHitTest); message CM_DESIGNHITTEST;
  protected
    procedure Loaded; override;
    procedure AdjustClientRect(var Rect: TRect); override;
    procedure GetChildren(Proc: TGetChildProc; Root: TComponent); override;
    procedure ShowControl(AControl: TControl); override;
    procedure Paint; override;
    procedure Resize; override;
    procedure InsertPage(Page: TKWizardCustomPage);
    procedure RemovePage(Page: TKWizardCustomPage);
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    function GetButtonControlClass(
      AKind: TKWizardButtonKind): TKWizardButtonControlClass; virtual;
  public
    constructor Create(AComponent: TComponent); override;
    destructor Destroy; override;
    procedure SelectPriorPage;
    procedure SelectNextPage;
    procedure SelectFirstPage;
    procedure SelectLastPage;
    function IsFirstPage(const APage: TKWizardCustomPage): Boolean;
    function IsLastPage(const APage: TKWizardCustomPage): Boolean;
    function FindNextPage(PageIndex, Step: Integer): TKWizardCustomPage;
    property ActivePageIndex: Integer
      read GetActivePageIndex write SetActivePageIndex;
    property PageCount: Integer
      read GetPageCount;
  published
    property Pages: TList
      read FPages;
    property About: TKWizardAboutInfo    // Add by Steve Forbes
      read FAboutInfo write FAboutInfo
      stored False;
    property ActivePage: TKWizardCustomPage
      read FActivePage write SetActivePage;
    property ButtonStart: TKWizardButton
      read FWizardButtons[bkStart] write FWizardButtons[bkStart];
    property ButtonLast: TKWizardButton
      read FWizardButtons[bkLast] write FWizardButtons[bkLast];
    property ButtonBack: TKWizardButton
      read FWizardButtons[bkBack] write FWizardButtons[bkBack];
    property ButtonNext: TKWizardButton
      read FWizardButtons[bkNext] write FWizardButtons[bkNext];
    property ButtonFinish: TKWizardButton
      read FWizardButtons[bkFinish] write FWizardButtons[bkFinish];
    property ButtonCancel: TKWizardButton
      read FWizardButtons[bkCancel] write FWizardButtons[bkCancel];
    property ShowDivider: Boolean
      read FShowDivider write SetShowDivider
      default True;
    property ShowRouteMap: Boolean
      read GetShowRouteMap write SetShowRouteMap;
    property HeaderImages: TCustomImageList
      read FHeaderImages write SetHeaderImages;
    property OnFirstPage: TKWizardChangePageEvent
      read FOnFirstPage write FOnFirstPage;
    property OnLastPage: TKWizardChangePageEvent
      read FOnLastPage write FOnLastPage;
    property OnNextPage: TKWizardChangePageEvent
      read FOnNextPage write FOnNextPage;
    property OnPriorPage: TKWizardChangePageEvent
      read FOnPriorPage write FOnPriorPage;
    property OnFirstButtonClick: TNotifyEvent index bkStart
      read GetButtonClick write SetButtonClick;
    property OnLastButtonClick: TNotifyEvent index bkLast
      read GetButtonClick write SetButtonClick;
    property OnBackButtonClick: TNotifyEvent index bkBack
      read GetButtonClick write SetButtonClick;
    property OnNextButtonClick: TNotifyEvent index bkNext
      read GetButtonClick write SetButtonClick;
    property OnFinishButtonClick: TNotifyEvent index bkFinish
      read GetButtonClick write SetButtonClick;
    property OnCancelButtonClick: TNotifyEvent index bkCancel
      read GetButtonClick write SetButtonClick;
    property Font;
    property Enabled;
    property Visible;
  end;

implementation

uses Forms, KCommon;

const

  ciButtonWidth = 75;
  ciButtonHeight = 25;
  ciButtonBarHeight = 42;
  ciButtonPlacement = (ciButtonBarHeight - ciButtonHeight) div 2;

resourcestring

  rsFirstButtonCaption = 'To &Start Page';
  rsLastButtonCaption = 'To &Last Page';
  rsBackButtonCaption = '< &Back';
  rsNextButtonCaption = '&Next >';
  rsCancelButtonCaption = 'Cancel';
  rsFinishButtonCaption = '&Finish';
  rsWelcome = 'Welcome';
  rsTitle = 'Title';
  rsSubtitle = 'Subtitle';
  rsInvalidParentControl = 'The Parent should be TKWizard or its descendants.';

{ TKWizardButtonControl }

constructor TKWizardButtonControl.Create(AOwner: TComponent);
begin
  inherited;
  if csDesigning in ComponentState then
  begin
    {$IFDEF DELPHI6}
      // !!! YW - Add csClickEvents in order to fired the Click method
      // at design time. It does NOT need at run time, otherwise it cause
      //the OnClick event to be fired twice.
    ControlStyle := ControlStyle + [csClickEvents];
    {$ENDIF}
    ControlStyle := ControlStyle + [csNoDesignVisible];
  end;
  Kind := bkCustom;
  Anchors := [akRight, akBottom];
end;

procedure TKWizardButtonControl.CMDesignHitTest(var Msg: TCMDesignHitTest);
begin
  inherited;
  if Enabled then
  begin
    Msg.Result := 1;
  end;
end;

procedure TKWizardButtonControl.CMVisibleChanged(var Msg: TMessage);
begin
  inherited;
  if Assigned(FWizard) then
  begin
    FWizard.RepositionButtons;
  end;
end;

{ TKWizardStartButton }

constructor TKWizardStartButton.Create(AOwner: TComponent);
begin
  inherited;
  Caption := rsFirstButtonCaption;
  Visible := False;
  Anchors := [akLeft, akBottom];
end;

procedure TKWizardStartButton.Click;
begin
  if not (csDesigning in ComponentState) then
  begin
    inherited;
  end;
  if Assigned(FWizard) then
  begin
    FWizard.SelectFirstPage;
  end;
end;

{ TKWizardLastButton }

constructor TKWizardLastButton.Create(AOwner: TComponent);
begin
  inherited;
  Caption := rsLastButtonCaption;
  Visible := False;
  Anchors := [akLeft, akBottom];
end;

procedure TKWizardLastButton.Click;
begin
  if not (csDesigning in ComponentState) then
  begin
    inherited;
  end;
  if Assigned(FWizard) then
  begin
    FWizard.SelectLastPage;
  end;
end;

{ TKWizardBackButton }

constructor TKWizardBackButton.Create(AOwner: TComponent);
begin
  inherited;
  Caption := rsBackButtonCaption;
  Enabled := False;
  Visible := True;
end;

procedure TKWizardBackButton.Click;
begin
  if not (csDesigning in ComponentState) then
  begin
    inherited;
  end;
  if Assigned(FWizard) then
  begin
    FWizard.SelectPriorPage;
  end;
end;

{ TKWizardNextButton }

constructor TKWizardNextButton.Create(AOwner: TComponent);
begin
  inherited;
  Caption := rsNextButtonCaption;
  Visible := True;
end;

procedure TKWizardNextButton.Click;
begin
  if not (csDesigning in ComponentState) then
  begin
    inherited;
  end;
  if Assigned(FWizard) then
  begin
    FWizard.SelectNextPage;
  end;
end;

{ TKWizardFinishButton }

constructor TKWizardFinishButton.Create(AOwner: TComponent);
begin
  inherited;
  Caption := rsFinishButtonCaption;
  Visible := True;
end;

procedure TKWizardFinishButton.Click;
begin
  if not (csDesigning in ComponentState) then
  begin
    inherited;
  end;
end;

{ TKWizardCancelButton }

constructor TKWizardCancelButton.Create(AOwner: TComponent);
begin
  inherited;
  Caption := rsCancelButtonCaption;
  Visible := True;
end;

procedure TKWizardCancelButton.Click;
begin
  if not (csDesigning in ComponentState) then
  begin
    inherited;
  end;
end;

{ TKWizardButton }

procedure TKWizardButton.SetWizardButtonControl(
  const Value: TKWizardButtonControl);
begin
  FWizardButtonControl := Value;
  FVisible := FWizardButtonControl.Visible;
end;

function TKWizardButton.GetCaption: string;
begin
  if Assigned(FWizardButtonControl) then
    Result := FWizardButtonControl.Caption
  else
    Result := '';
end;

function TKWizardButton.GetEnabled: Boolean;
begin
  if Assigned(FWizardButtonControl) then
    Result := FWizardButtonControl.Enabled
  else
    Result := False;
end;

function TKWizardButton.GetGlyph: TBitmap;
begin
  if Assigned(FWizardButtonControl) then
    Result := FWizardButtonControl.Glyph
  else
    Result := nil;
end;

function TKWizardButton.GetLayout: TButtonLayout;
begin
  if Assigned(FWizardButtonControl) then
    Result := FWizardButtonControl.Layout
  else
    Result := blGlyphLeft;
end;

function TKWizardButton.GetNumGlyphs: Integer;
begin
  if Assigned(FWizardButtonControl) then
    Result := FWizardButtonControl.NumGlyphs
  else
    Result := 0;
end;

procedure TKWizardButton.SetCaption(const Value: string);
begin
  if Assigned(FWizardButtonControl) then
  begin
    FWizardButtonControl.Caption := Value;
  end;
end;

procedure TKWizardButton.SetEnabled(const Value: Boolean);
begin
  if Assigned(FWizardButtonControl) then
  begin
    FWizardButtonControl.Enabled := Value;
  end;
end;

procedure TKWizardButton.SetGlyph(const Value: TBitmap);
begin
  if Assigned(FWizardButtonControl) then
  begin
    FWizardButtonControl.Glyph := Value;
  end;
end;

procedure TKWizardButton.SetNumGlyphs(const Value: Integer);
begin
  if Assigned(FWizardButtonControl) then
  begin
    FWizardButtonControl.NumGlyphs := Value;
  end;
end;

procedure TKWizardButton.SetLayout(const Value: TButtonLayout);
begin
  if Assigned(FWizardButtonControl) then
  begin
    FWizardButtonControl.Layout := Value;
  end;
end;

procedure TKWizardButton.SetVisible(const Value: Boolean);
begin
  FVisible := Value;
  if Assigned(FWizardButtonControl) then
  begin
    FWizardButtonControl.Visible := Value;
  end;
end;

{ TKWizardRouteMapControl }

constructor TKWizardRouteMapControl.Create(AOwner: TComponent);
begin
  inherited;
  // !!! YW - Add csNoDesignVisible in order to make it visible and invisible
  // at design Time.
  if csDesigning in ComponentState then
  begin
    ControlStyle := ControlStyle + [csNoDesignVisible];
  end;
  FAlign := waLeft;
  inherited Align := alLeft;
  TabStop := False;
  Width := 145;
  Visible := True;
  ParentColor := False;
  FPages := TList.Create;
  DoubleBuffered := True;
end;

destructor TKWizardRouteMapControl.Destroy;
begin
  if Assigned(Wizard) then
  begin
    Wizard.FWizardRouteMapControl := nil;
  end;
  FreeAndNil(FPages);
  inherited;
end;

procedure TKWizardRouteMapControl.DoAddPage(const APage: TKWizardCustomPage);
begin
  if Assigned(APage) and (FPages.IndexOf(APage) < 0) then
  begin
    FPages.Add(APage);
  end;
  WizardPageAdded(APage);
end;

procedure TKWizardRouteMapControl.DoDeletePage(const APage: TKWizardCustomPage);
var
  i: Integer;
begin
  if Assigned(APage) then
  begin
    i := FPages.Remove(APage);
    if FPageIndex = i then
    begin
      FPageIndex := -1;
    end;
  end;
  WizardPageDeleted(APage);
end;

procedure TKWizardRouteMapControl.DoActivatePage(const APage: TKWizardCustomPage);
begin
  if Assigned(APage) then
  begin
    FPageIndex := FPages.IndexOf(APage);
  end;
  WizardPageActivated(APage);
end;

procedure TKWizardRouteMapControl.DoUpdatePage(const APage: TKWizardCustomPage);
begin
  WizardPageUpdated(APage);
end;

procedure TKWizardRouteMapControl.DoMovePage(
  const APage: TKWizardCustomPage; const OldIndex: Integer);
begin
  if Assigned(APage) then
  begin
    FPages.Move(OldIndex, APage.PageIndex);
    if OldIndex = FPageIndex then
    begin
      FPageIndex := APage.PageIndex;
    end;
  end;
  WizardPageMoved(APage, OldIndex);
end;

procedure TKWizardRouteMapControl.SetAlign(Value: TKWizardAlign);
begin
  if FAlign <> Value then
  begin
    FAlign := Value;
    case FAlign of
      waLeft: inherited Align := alLeft;
      waRight: inherited Align := alRight;
      waTop: inherited Align := alTop;
      waBottom: inherited Align := alBottom;
    end;
  end;
end;

function TKWizardRouteMapControl.GetPage(Index: Integer): TKWizardCustomPage;
begin
  if (Index >= 0) and (Index < FPages.Count) then
    Result := TKWizardCustomPage(FPages[Index])
  else
    Result := nil;
end;

function TKWizardRouteMapControl.GetPageCount: Integer;
begin
  Result := FPages.Count;
end;

procedure TKWizardRouteMapControl.SetPageIndex(Value: Integer);
begin
  if (FPageIndex <> Value) and (Value >= 0) and (Value < PageCount) then
  begin
    FPageIndex := Value;
    SetActivePage(Pages[FPageIndex]);
  end;
end;

procedure TKWizardRouteMapControl.CMDesignHitTest(var Msg: TCMDesignHitTest);
begin
  Msg.Result := 1;
end;

procedure TKWizardRouteMapControl.SetActivePage(APage: TKWizardCustomPage);
begin
  if Assigned(FWizard) and (APage.Wizard = FWizard) then
  begin
    FWizard.SetActivePage(APage);
  end;
end;

function TKWizardRouteMapControl.PageAtPos(Pos: TPoint): Integer;
begin
  // YW - Return the index of a page at the particular point in the route
  // map control. Returns -1 if no page at this particular point.
  Result := -1;
end;

procedure TKWizardRouteMapControl.MouseDown(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  i: Integer;
begin
  if Button = mbLeft then
  begin
    i := PageAtPos(Point(X, Y));
    if (i >= 0) and ((csDesigning in ComponentState) or Pages[i].Enabled) then
    begin
      PageIndex := i;
    end;
  end;
  inherited;
end;

procedure TKWizardRouteMapControl.SetParent(AParent: TWinControl);
var
  i: Integer;
begin
  if Assigned(AParent) and (not (AParent is TKWizard)) then
  begin
    raise EKWizard.Create(rsInvalidParentControl);
  end;
  inherited;
  if Assigned(AParent) then
  begin
    FWizard := TKWizard(AParent);
    FWizard.FWizardRouteMapControl := Self;
    FPages.Clear;
    if Assigned(FWizard) then
    begin
      for i := 0 to FWizard.PageCount - 1 do
      begin
        FPages.Add(FWizard.FPages[i]);
      end;
    end;
  end;
end;

procedure TKWizardRouteMapControl.WizardPageActivated(
  const APage: TKWizardCustomPage);
begin
  // YW - Called after the page becomes the current active page of wizard.
end;

procedure TKWizardRouteMapControl.WizardPageAdded(
  const APage: TKWizardCustomPage);
begin
  // YW - Called after the new page added into wizard.
end;

procedure TKWizardRouteMapControl.WizardPageDeleted(
  const APage: TKWizardCustomPage);
begin
  // YW - Called after the page is removed from.
  // Note: do NOT free this page.
end;

procedure TKWizardRouteMapControl.WizardPageMoved(
  const APage: TKWizardCustomPage; const OldIndex: Integer);
begin
  // YW - Called after page is changed its page order.
end;

procedure TKWizardRouteMapControl.WizardPageUpdated(
  const APage: TKWizardCustomPage);
begin
  // YW - Called when the page change its status or caption.
end;

{ TKWizardPageTitle }

constructor TKWizardPageTitle.Create;
begin
  FAnchorPlacement := 4;
  FIndent := 0;
  FAnchors := [akLeft, akTop];
  FAlignment := taLeftJustify;
  FFont := TFont.Create;
end;

destructor TKWizardPageTitle.Destroy;
begin
  FreeAndNil(FFont);
  inherited;
end;

procedure TKWizardPageTitle.DoChange;
begin
  if Assigned(FOnChange) then
  begin
    FOnChange(Self);
  end;
end;

function TKWizardPageTitle.GetTextRect(const ACanvas: TCanvas;
  const ARect: TRect): TRect;
var
  ATextSize: TSize;
begin
  ATextSize := ACanvas.TextExtent(FText);
  Result := Bounds(ARect.Left, ARect.Top, ATextSize.cx, ATextSize.cy);
  if akLeft in FAnchors then
  begin
    OffsetRect(Result, FAnchorPlacement, 0);
  end;
  if akTop in FAnchors then
  begin
    OffsetRect(Result, 0, FAnchorPlacement);
  end;
  if akRight in FAnchors then
  begin
    Result.Right := ARect.Right - FAnchorPlacement;
  end;
  if akBottom in FAnchors then
  begin
    Result.Bottom := ARect.Bottom - FAnchorPlacement;
  end;
  Inc(Result.Left, FIndent);
  if Result.Bottom > ARect.Bottom then
  begin
    Result.Bottom := ARect.Bottom;
  end;
  if Result.Right > ARect.Right then
  begin
    Result.Right := ARect.Right;
  end;
end;

function TKWizardPageTitle.PaintTo(ACanvas: TCanvas; ARect: TRect;
  ShowOutline: Boolean): Integer;
const
  Alignments: array[TAlignment] of Integer = (DT_LEFT, DT_CENTER, DT_RIGHT);
begin
  Result := ARect.Top;
  if Trim(FText) <> '' then
  begin
    ACanvas.Font.Assign(FFont);
    ARect := GetTextRect(ACanvas, ARect);
    with ACanvas do
    begin
      Brush.Style := bsClear;
      DrawText(ACanvas.Handle, PChar(FText), -1, ARect,
               DT_WORDBREAK + Alignments[FAlignment]);
      if ShowOutline then
      begin
       { Draw outline }
        Pen.Style := psDot;
        Pen.Mode := pmXor;
        Pen.Color := $00FFD8CE;
        Brush.Style := bsClear;
        Rectangle(ARect);
      end;
    end;
    Result := ARect.Bottom;
  end;
end;

procedure TKWizardPageTitle.SetAlignment(Value: TAlignment);
begin
  if FAlignment <> Value then
  begin
    FAlignment := Value;
    DoChange;
  end;
end;

procedure TKWizardPageTitle.SetAnchors(Value: TAnchors);
begin
  if FAnchors <> Value then
  begin
    FAnchors := Value;
    DoChange;
  end;
end;

procedure TKWizardPageTitle.SetIndent(Value: Integer);
begin
  if FIndent <> Value then
  begin
    FIndent := Value;
    DoChange;
  end;
end;

procedure TKWizardPageTitle.SetFont(Value: TFont);
begin
  if FFont <> Value then
    FFont.Assign(Value);
end;

procedure TKWizardPageTitle.SetText(Value: string);
begin
  if FText <> Value then
  begin
    FText := Value;
    DoChange;
  end;
end;

procedure TKWizardPageTitle.SetAnchorPlacement(Value: Integer);
begin
  if FAnchorPlacement <> Value then
  begin
    FAnchorPlacement := Value;
    DoChange;
  end;
end;

procedure TKWizardPageTitle.SetOnChange(Value: TNotifyEvent);
begin
  FOnChange := Value;
  if Assigned(FFont) then
  begin
    FFont.OnChange := Value;
  end;
end;

{ TKWizardPersistent }

constructor TKWizardPersistent.Create;
begin
  FColor := clBtnFace;
  FVisible := True;
end;

procedure TKWizardPersistent.DoChange;
begin
  if Assigned(FWizardPage) then
  begin
    FWizardPage.Invalidate;
  end;
end;

procedure TKWizardPersistent.SetColor(Value: TColor);
begin
  if FColor <> Value then
  begin
    FColor := Value;
    DoChange;
  end;
end;

procedure TKWizardPersistent.SetVisible(Value: Boolean);
begin
  if FVisible <> Value then
  begin
    FVisible := Value;
    DoChange;
  end;
end;

procedure TKWizardPersistent.SetWizardPage(Value: TKWizardCustomPage);
begin
  FWizardPage := Value;
end;

{ TKWizardPageHeader }

constructor TKWizardPageHeader.Create;
begin
  inherited;
  Color := clWindow;
  FHeight := 70;
  FParentFont := True;
  { Set up Title }
  FTitle := TKWizardPageTitle.Create;
  FTitle.FText := rsTitle;
  FTitle.Anchors := [akLeft, akTop, akRight];
  FTitle.FFont.Size := 12;
  FTitle.FFont.Style := [fsBold];
  FTitle.OnChange := OnChange;
  { Set up Subtitle }
  FSubtitle := TKWizardPageTitle.Create;
  FSubtitle.Anchors := [akLeft, akTop, akRight, akBottom];
  FSubtitle.FText := rsSubtitle;
  FSubtitle.OnChange := OnChange;
  FImageAlign := waRight;
  FImageOffset := 0;
  FImageIndex := -1;
end;

destructor TKWizardPageHeader.Destroy;
begin
  FreeAndNil(FTitle);
  FreeAndNil(FSubtitle);
  inherited;
end;

procedure TKWizardPageHeader.SetHeight(Value: Integer);
begin
  if FHeight <> Value then
  begin
    FHeight := Value;
    DoChange;
  end;
end;

procedure TKWizardPageHeader.SetImageIndex(Value: Integer);
begin
  if FImageIndex <> Value then
  begin
    FImageIndex := Value;
    DoChange;
  end;
end;

procedure TKWizardPageHeader.SetImageOffset(Value: Integer);
begin
  if FImageOffset <> Value then
  begin
    FImageOffset := Value;
    DoChange;
  end;
end;

procedure TKWizardPageHeader.SetImageAlign(Value: TKWizardLeftRightAlign);
begin
  if FImageAlign <> Value then
  begin
    FImageAlign := Value;
    DoChange;
  end;
end;

procedure TKWizardPageHeader.ChangeFont;
begin
  if Assigned(FWizardPage) then
  begin
    FTitle.FFont.Name := FWizardPage.Font.Name;
    FTitle.FFont.Charset := FWizardPage.Font.Charset;
    FSubtitle.FFont.Name := FWizardPage.Font.Name;
    FSubtitle.FFont.Charset := FWizardPage.Font.Charset;
  end;
end;

procedure TKWizardPageHeader.SetWizardPage(Value: TKWizardCustomPage);
begin
  inherited;
  if FParentFont then
  begin
    ChangeFont;
  end;
end;

procedure TKWizardPageHeader.OnChange(Sender: TObject);
begin
  DoChange;
end;

function TKWizardPageHeader.GetImageRect(const AImages: TCustomImageList;
  var ARect: TRect): TRect;
begin
  Result := Bounds(ARect.Left, ARect.Top, AImages.Width, AImages.Height);
  OffsetRect(Result, 0, ((ARect.Bottom - ARect.Top) - AImages.Height) div 2);
  if FImageAlign = waRight then
  begin
    OffsetRect(Result, ARect.Right - ARect.Left - AImages.Width - 4, 0);
  end;
  OffsetRect(Result, FImageOffset, 0);
  if FImageAlign = waLeft then
  begin
    // if right side of the image area still in the page header area
    // then adjust the left side of title area.
    if Result.Right > ARect.Left then
      ARect.Left := Result.Right;
  end
  else // must be waRight
  begin
    // if left side of the image area still in the page header area
    // then adjust the ride side of title area.
    if Result.Left < ARect.Right then
      ARect.Right := Result.Left;
  end;
end;

procedure TKWizardPageHeader.PaintTo(ACanvas: TCanvas; var ARect: TRect;
  ShowHeaderDivider, ShowTitleOutline: Boolean);
var
  R, ImageRect: TRect;
  AImages: TCustomImageList;
begin
  if Visible then
  begin
    R := ARect;
    R.Bottom := R.Top + FHeight;
    with ACanvas do
    begin
      Brush.Style := bsSolid;
      Brush.Color := Color;
      FillRect(R);
    end;
    // YW - Show Header Divider if necessary
    if ShowHeaderDivider then
    begin
      KDrawBorderEdges(ACanvas, R, fsGroove, [beBottom]);
    end;
    // YW - Draw Header Image first
    if Assigned(WizardPage) and Assigned(WizardPage.Wizard) then
    begin
      AImages := WizardPage.Wizard.HeaderImages;
      if Assigned(AImages) and (FImageIndex >= 0) and
        (FImageIndex < AImages.Count) then
      begin
        ImageRect := GetImageRect(AImages, R);
        // R = the area where the title and subtitle paint to.
        AImages.Draw(ACanvas, ImageRect.Left, ImageRect.Top, FImageIndex, True);
      end;
    end;
    // YW - Draw Title
    R.Top := FTitle.PaintTo(ACanvas, R, ShowTitleOutline);
    // YW - Draw Subtitle
    FSubtitle.PaintTo(ACanvas, R, ShowTitleOutline);
    Inc(ARect.Top, FHeight);
  end;
end;

procedure TKWizardPageHeader.SetParentFont(Value: Boolean);
begin
  if FParentFont <> Value then
  begin
    FParentFont := Value;
    if FParentFont then
    begin
      ChangeFont;
    end;
  end;
end;

{ TKWizardWaterMark }

constructor TKWizardWaterMark.Create;
begin
  inherited;
  FAlign := waLeft;
  Color := clActiveCaption;
  FWidth := 164;
  FBorderWidth := 1;
  FImage := TPicture.Create;
  FImage.OnChange := ImageChanged;
end;

destructor TKWizardWaterMark.Destroy;
begin
  FreeAndNil(FImage);
  inherited;
end;

procedure TKWizardWaterMark.SetBorderWidth(Value: Integer);
begin
  if FBorderWidth <> Value then
  begin
    FBorderWidth := Value;
    DoChange;
  end;
end;

procedure TKWizardWaterMark.SetAlign(Value: TKWizardLeftRightAlign);
begin
  if FAlign <> Value then
  begin
    FAlign := Value;
    DoChange;
  end;
end;

procedure TKWizardWaterMark.SetWidth(Value: Integer);
begin
  if FWidth <> Value then
  begin
    FWidth := Value;
    DoChange;
  end;
end;

procedure TKWizardWaterMark.PaintTo(ACanvas: TCanvas; var ARect: TRect);
var
  R: TRect;
  AHeight: Integer;
begin
  if Visible then
  begin
    AHeight := ARect.Bottom - ARect.Top;
    if FAlign = waLeft then
    begin
      R := Bounds(ARect.Left, ARect.Top, FWidth, AHeight);
      Inc(ARect.Left, FWidth);
    end
    else
    begin
      R := Bounds(ARect.Right - FWidth, ARect.Top, FWidth, AHeight);
      Dec(ARect.Right, FWidth);
    end;
    InflateRect(R, -FBorderWidth, -FBorderWidth);
    with ACanvas do
    begin
      Brush.Style := bsSolid;
      Brush.Color := Color;
      FillRect(R);
    end;
    if Assigned(FImage.Graphic) then
    begin
      ACanvas.StretchDraw(R, FImage.Graphic);
    end;
  end;
end;

procedure TKWizardWaterMark.ImageChanged(Sender: TObject);
var
  AGraphic: TGraphic;
begin
  AGraphic := FImage.Graphic;
  if Assigned(AGraphic) then
  begin
    if not ((AGraphic is TMetaFile) or (AGraphic is TIcon)) then
    begin
      AGraphic.Transparent := True;
    end;
  end;
  // YW - when reset the graphic, we still need to update the screen.
  DoChange;
end;

procedure TKWizardWaterMark.SetImage(Value: TPicture);
begin
  FImage.Assign(Value);
end;

{ TKWizardPagePanel }

constructor TKWizardPagePanel.Create;
begin
  inherited;
  FBorderWidth := 7;
  Color := clBtnFace;
  Visible := False;
end;

procedure TKWizardPagePanel.PaintTo(ACanvas: TCanvas; var ARect: TRect);
begin
  if Visible and (FBorderWidth > 0) then
  begin
    InflateRect(ARect, -FBorderWidth, -FBorderWidth);
    KDrawBorderEdges(ACanvas, ARect, fsGroove, beAllEdges);
    // YW - clNone means transparent
    if Color <> clNone then
    begin
      InflateRect(ARect, -2, -2);
      with ACanvas do
      begin
        Brush.Style := bsSolid;
        Brush.Color := Color;
        FillRect(ARect);
      end;
    end;
  end;
end;

procedure TKWizardPagePanel.SetBorderWidth(Value: Word);
begin
  if FBorderWidth <> Value then
  begin
    FBorderWidth := Value;
    DoChange;
  end;
end;

{ TKWizardCustomPage }

constructor TKWizardCustomPage.Create(AOwner: TComponent);
begin
  inherited;
  Align := alClient;
  ControlStyle := ControlStyle + [csAcceptsControls, csNoDesignVisible];
  ParentColor := False;
  Visible := False;
  Color := clBtnFace;
  FHeader := TKWizardPageHeader.Create;
  FHeader.WizardPage := Self;
  FImage := TPicture.Create;
  FImage.OnChange := ImageChanged;
  FPanel := TKWizardPagePanel.Create;
  FPanel.WizardPage := Self;
  // YW - try to avoid screen flicker, it paints its image
  // into memory, then move image memory to the screen at once.
  DoubleBuffered := True;
end;

destructor TKWizardCustomPage.Destroy;
begin
  if Assigned(FWizard) then
  begin
    FWizard.RemovePage(Self);
  end;
  FreeAndNil(FPanel);
  FreeAndNil(FImage);
  FreeAndNil(FHeader);
  inherited;
end;

procedure TKWizardCustomPage.CreateParams(var Params: TCreateParams);
begin
  inherited;
  with Params.WindowClass do
  begin
    Style := Style and not (CS_HREDRAW or CS_VREDRAW);
  end;
end;

procedure TKWizardCustomPage.CMEnabledChanged(var Message: TMessage);
var
  NextPage: TKWizardCustomPage;
begin
  inherited;
  if Assigned(FWizard) then
  begin
    if Assigned(FWizard.FWizardRouteMapControl) then
    begin
      FWizard.FWizardRouteMapControl.DoUpdatePage(Self);
    end;
    if not ((csDesigning in ComponentState) or Enabled) and
       (FWizard.ActivePage = Self) then
    begin
      NextPage := FWizard.FindNextPage(PageIndex, 1);
      if not Assigned(NextPage) then
      begin
        NextPage := FWizard.FindNextPage(PageIndex, -1);
      end;
      FWizard.SetActivePage(NextPage);
    end;
  end;
end;

procedure TKWizardCustomPage.CMTextChanged(var Message: TMessage);
begin
  Invalidate;
  if Assigned(FWizard) and Assigned(FWizard.FWizardRouteMapControl) then
  begin
    FWizard.FWizardRouteMapControl.DoUpdatePage(Self);
  end;
end;

procedure TKWizardCustomPage.SetWizard(AWizard: TKWizard);
begin
  if FWizard <> AWizard then
  begin
    if Assigned(FWizard) then
    begin
      FWizard.RemovePage(Self);
    end;
    Parent := AWizard;
    if Assigned(AWizard) then
    begin
      AWizard.InsertPage(Self);
    end;
  end;
end;

function TKWizardCustomPage.GetPageIndex: Integer;
begin
  if Assigned(FWizard) then
    Result := FWizard.FPages.IndexOf(Self)
  else
    Result := -1;
end;

function TKWizardCustomPage.GetButtons(Index: TKWizardButtonKind): TKWizardButton;
begin
  if Assigned(FWizard) and Assigned(FWizard.FWizardButtons[Index]) then
    Result := FWizard.FWizardButtons[Index]
  else
    Result := nil;
end;

procedure TKWizardCustomPage.ReadState(Reader: TReader);
begin
  inherited;
  if Reader.Parent is TKWizard then
  begin
    Wizard := TKWizard(Reader.Parent);
  end;
end;

procedure TKWizardCustomPage.SetPageIndex(const Value: Integer);
var
  OldIndex: Integer;
begin
  if Assigned(FWizard) and (Value >= 0) and (Value < FWizard.FPages.Count) then
  begin
    OldIndex := PageIndex;
    FWizard.FPages.Move(OldIndex, Value);
    if Assigned(FWizard.FWizardRouteMapControl) then
    begin
      FWizard.FWizardRouteMapControl.DoMovePage(Self, OldIndex);
    end;
  end;
end;

procedure TKWizardCustomPage.WMEraseBkgnd(var Message: TWmEraseBkgnd);
begin
  Message.Result := 1;
end;

procedure TKWizardCustomPage.Paint;
var
  ARect: TRect;
begin
  if FDrawing then Exit;
  FDrawing := True;
  try
    ARect := ClientRect;
    with Canvas do
    begin
      Brush.Style := bsSolid;
      Brush.Color := Color;
      FillRect(ARect);
    end;
    PaintPage(Canvas, ARect);
    if Assigned(FOnPaintPage) and not (csDesigning in ComponentState) then
      FOnPaintPage(Self, Canvas, ARect)
    else
    begin
      // YW - Paint the image first in prevent the image from covering
      // the panel.
      if Assigned(FImage.Graphic) then
      begin
        Canvas.StretchDraw(ARect, FImage.Graphic);
      end;
      if Assigned(FPanel) then
      begin
        FPanel.PaintTo(Canvas, ARect);
      end;
    end;
    // YW - display page name at design time.
    if csDesigning in ComponentState then
    begin
      Canvas.Brush.Style := bsClear;
      Canvas.Font.Assign(Font);
      DrawText(Canvas.Handle, PChar(Caption), -1, ARect,
               DT_SINGLELINE + DT_CENTER + DT_VCENTER);

    end;
  finally
    FDrawing := False;
  end;
end;

procedure TKWizardCustomPage.PaintPage(ACanvas: TCanvas; var ARect: TRect);
begin
  // YW - all derived page control should call this method to paint itsself
  // rather than call the overrided paint method.
end;

procedure TKWizardCustomPage.Done;
begin
  if Assigned(FOnPage) and Enabled and
     not (csDesigning in ComponentState) then
  begin
    FOnPage(Self);
  end;
end;

procedure TKWizardCustomPage.Enter;
begin
  if Assigned(FOnEnterPage) and Enabled and
     not (csDesigning in ComponentState) then
  begin
    FOnEnterPage(Self);
  end;
end;

procedure TKWizardCustomPage.Exit;
begin
  if Assigned(FOnExitPage) and Enabled and
     not (csDesigning in ComponentState) then
  begin
    FOnExitPage(Self);
  end;
end;

procedure TKWizardCustomPage.SetImage(Value: TPicture);
begin
  FImage.Assign(Value);
end;

procedure TKWizardCustomPage.ImageChanged(Sender: TObject);
var
  AGraphic: TGraphic;
begin
  AGraphic := FImage.Graphic;
  if Assigned(AGraphic) then
  begin
    if not ((AGraphic is TMetaFile) or (AGraphic is TIcon)) then
    begin
      AGraphic.Transparent := True;
    end;
  end;
  // YW - when reset the graphic, we still need to update the page screen.
  Invalidate;
end;

procedure TKWizardCustomPage.CMFontChanged(var Message: TMessage);
begin
  if FHeader.ParentFont then
  begin
    FHeader.ChangeFont;
  end;
  inherited;
end;

{ TKWizardWelcomePage }

constructor TKWizardWelcomePage.Create(AOwner: TComponent);
begin
  inherited;
  FWaterMark := TKWizardWaterMark.Create;
  FWaterMark.WizardPage := Self;
  FHeader.FTitle.FText := rsWelcome;
  Color := clWindow;
end;

destructor TKWizardWelcomePage.Destroy;
begin
  FreeAndNil(FWaterMark);
  inherited;
end;

procedure TKWizardWelcomePage.PaintPage(ACanvas: TCanvas; var ARect: TRect);
begin
  if Assigned(FWaterMark) then
  begin
    FWaterMark.PaintTo(ACanvas, ARect);
  end;
  if Assigned(FHeader) then
  begin
    FHeader.PaintTo(ACanvas, ARect, csDesigning in ComponentState,
      csDesigning in ComponentState);
  end;
end;

{ TKWizardInteriorPage }

procedure TKWizardInteriorPage.PaintPage(ACanvas: TCanvas;
  var ARect: TRect);
begin
  if Assigned(FHeader) then
  begin
    FHeader.PaintTo(ACanvas, ARect, True, csDesigning in ComponentState);
  end;
end;

{ TKWizard }

constructor TKWizard.Create(AComponent: TComponent);
begin
  inherited;
  // YW - In order to accept TKWizardRouteMap control, we need to add
  // csAcceptsControls ControlStyle
  ControlStyle := ControlStyle + [csAcceptsControls]- [csSetCaption];
  FPages := TList.Create;
  Align := alClient;
  FShowDivider := True;
  FImageChangeLink := TChangeLink.Create;
  FImageChangeLink.OnChange := ImageListChange;
  CreateNavigationButtons;
end;

destructor TKWizard.Destroy;
var
  i: Integer;
  AKind: TKWizardButtonKind;
begin
  for AKind := Low(TKWizardButtonKind) to High(TKWizardButtonKind) do
  begin
    FWizardButtons[AKind].Free;
  end;
  // !!! YW - Reset wizard property value of all wizard pages FIRST,
  // so that when the actual wizard page control being freed,
  // it won't call Wizard.RemovePage, otherwise it will cause AV,
  // because at that time FPages has already been destroyed.
  for i := 0 to FPages.Count - 1 do
  begin
    TKWizardCustomPage(FPages[i]).FWizard := nil;
  end;
  FreeAndNil(FImageChangeLink);
  FPages.Free;
  inherited;
end;

procedure TKWizard.Loaded;
begin
  inherited;
  RepositionButtons;
  // YW - When the wizard shows up, we default it to the first page always.
  if FPages.Count > 0 then
  begin
    SelectFirstPage;
  end;
end;

procedure TKWizard.CreateNavigationButtons;
var
  AKind: TKWizardButtonKind;
begin
  // !!! YW - the Finish Button should be created before the Next button
  // is created, so the Next button can cover the Finish button
  // at startup.
  for AKind := Low(TKWizardButtonKind) to High(TKWizardButtonKind) do
  begin
    FButtonControls[AKind] := GetButtonControlClass(AKind).Create(Self);
    FButtonControls[AKind].Parent := Self;
    FButtonControls[AKind].Width := ciButtonWidth;
    FButtonControls[AKind].Height := ciButtonHeight;
    FButtonControls[AKind].Wizard := Self;
    FWizardButtons[AKind] := TKWizardButton.Create;
    FWizardButtons[AKind].WizardButtonControl := FButtonControls[AKind];
  end;
end;

function TKWizard.FindNextPage(PageIndex, Step: Integer): TKWizardCustomPage;
begin
  // !!! YW - Only the Enabled property of the page can tell if it should be
  // ignore or skip. It can not use Visible property to test that, because
  // all pages are invisible(Visible = False) at startup until they
  // are actived.
  Result := nil;
  repeat
    Inc(PageIndex, Step);
  until (csDesigning in ComponentState) or
        (PageIndex < 0) or (PageIndex >= FPages.Count) or
        TKWizardCustomPage(FPages[PageIndex]).Enabled;
  if csDesigning in ComponentState then
  begin
    if PageIndex < 0 then
      PageIndex := FPages.Count - 1
    else if PageIndex >= FPages.Count then
      PageIndex := 0;
  end;
  if (PageIndex >= 0) and (PageIndex < FPages.Count) and
     ((csDesigning in ComponentState) or
      (TKWizardCustomPage(FPages[PageIndex]).Enabled)) then
    Result := TKWizardCustomPage(FPages[PageIndex]);
end;

procedure TKWizard.SelectFirstPage;
var
  AFirstPage: TKWizardCustomPage;
begin
  AFirstPage := FindNextPage(-1, 1);
  if Assigned(AFirstPage) and not (csDesigning in ComponentState) and
     Assigned(FOnFirstPage) then
  begin
    FOnFirstPage(Self, FActivePage, AFirstPage);
  end;
  if Assigned(AFirstPage) then
  begin
    SetActivePage(AFirstPage);
  end;
end;

procedure TKWizard.SelectLastPage;
var
  ALastPage: TKWizardCustomPage;
begin
  ALastPage := FindNextPage(FPages.Count, -1);
  if Assigned(ALastPage) and not (csDesigning in ComponentState) and
     Assigned(FOnLastPage) then
  begin
    FOnLastPage(Self, FActivePage, ALastPage);
  end;
  if Assigned(ALastPage) then
  begin
    SetActivePage(ALastPage);
  end;
end;

procedure TKWizard.SelectNextPage;
var
  ANextPage: TKWizardCustomPage;
begin
  ANextPage := FindNextPage(GetActivePageIndex, 1);
  if Assigned(ANextPage) and not (csDesigning in ComponentState) and
     Assigned(FOnNextPage) then
  begin
    FOnNextPage(Self, FActivePage, ANextPage);
  end;
  if Assigned(ANextPage) then
  begin
    SetActivePage(ANextPage);
  end;
end;

procedure TKWizard.SelectPriorPage;
var
  APriorPage: TKWizardCustomPage;
begin
  APriorPage := FindNextPage(GetActivePageIndex, -1);
  if Assigned(APriorPage) and not (csDesigning in ComponentState) and
     Assigned(FOnPriorPage) then
  begin
    FOnFirstPage(Self, FActivePage, APriorPage);
  end;
  if Assigned(APriorPage) then
  begin
    SetActivePage(APriorPage);
  end;
end;

function TKWizard.IsFirstPage(const APage: TKWizardCustomPage): Boolean;
var
  AFirstPage: TKWizardCustomPage;
begin
  AFirstPage := FindNextPage(-1, 1);
  Result := not Assigned(AFirstPage) or (APage = AFirstPage);
end;

function TKWizard.IsLastPage(const APage: TKWizardCustomPage): Boolean;
var
  ALastPage: TKWizardCustomPage;
begin
  ALastPage := FindNextPage(FPages.Count, -1);
  Result := not Assigned(ALastPage) or (APage = ALastPage);
end;

procedure TKWizard.SetActivePage(Page: TKWizardCustomPage);
begin
  if (not Assigned(Page)) or (Page.Wizard = Self) then
  begin
    ChangeActivePage(Page);
  end;
end;

procedure TKWizard.ChangeActivePage(Page: TKWizardCustomPage);
var
  ParentForm: TCustomForm;
begin
  if FActivePage <> Page then
  begin
    ParentForm := GetParentForm(Self);
    if Assigned(ParentForm) and Assigned(FActivePage) and
       FActivePage.ContainsControl(ParentForm.ActiveControl) then
    begin
      ParentForm.ActiveControl := FActivePage;
    end;
    if Assigned(Page) then
    begin
      // YW - FActivePage.Enter, should be called before the page shows up.
      Page.Enter;
      Page.BringToFront;
      Page.Visible := True;
      if Assigned(ParentForm) then
      begin
        if Page.CanFocus then
          ParentForm.ActiveControl := Page
        else
          ParentForm.ActiveControl := Self;
      end;
    end;
    if Assigned(FActivePage) then
    begin
      FActivePage.Visible := False;
      // YW - FActivePage.Exit, should be called after the page is hidden.
      FActivePage.Exit;
    end;
    FActivePage := Page;
    if Assigned(ParentForm) and Assigned(FActivePage) and
       (ParentForm.ActiveControl = FActivePage) then
    begin
      FActivePage.SelectFirst;
    end;
    if Assigned(FWizardRouteMapControl) then
    begin
      FWizardRouteMapControl.DoActivatePage(FActivePage);
    end;
    UpdateButtonControlsStatus;
    // YW - FActivePage.Done, should be called after UpdateButtonControlsStatus
    // so the developers has the chance to override all buttons status.
    if Assigned(FActivePage) then
    begin
      FActivePage.Done;
    end;
  end;
end;

procedure TKWizard.InsertPage(Page: TKWizardCustomPage);
begin
  FPages.Add(Page);
  Page.FWizard := Self;
  if Assigned(FWizardRouteMapControl) then
  begin
    FWizardRouteMapControl.DoAddPage(Page);
  end;
end;

procedure TKWizard.RemovePage(Page: TKWizardCustomPage);
var
  NextPage: TKWizardCustomPage;
begin
  NextPage := FindNextPage(Page.PageIndex, 1);
  if NextPage = Page then // Fixed the AV when delete the only one page.
  begin
    NextPage := nil;
  end;
  if Assigned(FWizardRouteMapControl) then
  begin
    FWizardRouteMapControl.DoDeletePage(Page);
  end;
  Page.FWizard := nil;
  FPages.Remove(Page);
  SetActivePage(NextPage);
  //!!! YW - It must not call Page.Free, becaure page is the child control of
  //the wizard now, so when the wizard being destroy, this page will be
  //destroyed too.
end;

function TKWizard.GetActivePageIndex: Integer;
begin
  if Assigned(ActivePage) then
    Result := ActivePage.PageIndex
  else
    Result := -1;
end;

procedure TKWizard.SetActivePageIndex(Value: Integer);
begin
  if (Value >= 0) and (Value < PageCount) then
    ActivePage := TKWizardCustomPage(FPages[Value])
  else
    ActivePage := nil;
end;

procedure TKWizard.WMEraseBkgnd(var Message: TWmEraseBkgnd);
begin
  Message.Result := 1;
end;

procedure TKWizard.Paint;
var
  R: TRect;
begin
  R := ClientRect;
  if Color <> clNone then
  begin
    Canvas.Brush.Color := Color;
    Canvas.Brush.Style := bsSolid;
    Canvas.FillRect(R);
  end;
  if FShowDivider then
  begin
    R.Top := R.Bottom - ciButtonBarHeight;
    KDrawBorderEdges(Canvas, R, fsGroove, [beTop]);
  end;
end;

procedure TKWizard.SetShowDivider(Value: Boolean);
begin
  if FShowDivider <> Value then
  begin
    FShowDivider := Value;
    Invalidate;
  end;
end;

function TKWizard.GetShowRouteMap: Boolean;
begin
  if Assigned(FWizardRouteMapControl) then
    Result := FWizardRouteMapControl.Visible
  else
    Result := False;
end;

procedure TKWizard.SetShowRouteMap(Value: Boolean);
begin
  if Assigned(FWizardRouteMapControl) then
  begin
    FWizardRouteMapControl.Visible := Value;
  end;
end;

procedure TKWizard.SetHeaderImages(Value: TCustomImageList);
begin
  if Assigned(FHeaderImages) then
  begin
    FHeaderImages.UnRegisterChanges(FImageChangeLink);
  end;
  FHeaderImages := Value;
  if Assigned(FHeaderImages) then
  begin
    FHeaderImages.RegisterChanges(FImageChangeLink);
    FHeaderImages.FreeNotification(Self);
  end;
  if Assigned(FActivePage) then
  begin
    FActivePage.Invalidate;
  end;
end;

function TKWizard.GetButtonClick(const Index: TKWizardButtonKind): TNotifyEvent;
begin
  if Assigned(FButtonControls[Index]) then
    Result := FButtonControls[Index].OnClick
  else
    Result := nil;
end;

procedure TKWizard.SetButtonClick(const Index: TKWizardButtonKind;
  const Value: TNotifyEvent);
begin
  if Assigned(FButtonControls[Index]) then
  begin
    FButtonControls[Index].OnClick := Value;
  end;
end;

function TKWizard.GetPageCount: Integer;
begin
  Result := FPages.Count;
end;

procedure TKWizard.CMDesignHitTest(var Message: TCMDesignHitTest);
var
  P: TPoint;
begin
  P := SmallPointToPoint(Message.Pos);
  if Assigned(FActivePage) and PtInRect(FActivePage.BoundsRect, P) then
  begin
    Message.Result := 1;
  end;
end;

procedure TKWizard.AdjustClientRect(var Rect: TRect);
begin
  // YW - All wizard's child controls (Pages, RouteMap, etc) whose align
  // property set to (alTop, alLeft, alTop, alBottom, alClient) will call
  // this procedure to adjust their bounds. All navigate buttons would not
  // call it because they do not have align set, so they can display at
  // the bottom of the wizard.
  inherited;
  Rect.Bottom := Rect.Bottom - ciButtonBarHeight;
end;

procedure TKWizard.WMGetDlgCode(var Message: TWMGetDlgCode);
begin
  Message.Result := DLGC_WANTALLKEYS or DLGC_WANTARROWS;
end;

function TKWizard.GetButtonControlClass(
  AKind: TKWizardButtonKind): TKWizardButtonControlClass;
begin
  case AKind of
    bkStart:  Result := TKWizardStartButton;
    bkLast:   Result := TKWizardLastButton;
    bkBack:   Result := TKWizardBackButton;
    bkNext:   Result := TKWizardNextButton;
    bkFinish: Result := TKWizardFinishButton;
    bkCancel: Result := TKWizardCancelButton;
  else
    Result := TKWizardButtonControl;
  end;
end;

procedure TKWizard.RepositionButtons;
var
  ATop: Integer;
  ALeft: Integer;
  AWidth: Integer;
begin
  ATop := ClientRect.Bottom - ciButtonPlacement - ciButtonHeight;
  ALeft := ClientRect.Left + ciButtonPlacement;
  AWidth := ciButtonWidth + 30;
  if FButtonControls[bkStart].Visible then
  begin
    FButtonControls[bkStart].SetBounds(ALeft, ATop, AWidth, ciButtonHeight);
    Inc(ALeft, AWidth + 1);
  end;
  if FButtonControls[bkLast].Visible then
  begin
    FButtonControls[bkLast].SetBounds(ALeft, ATop, AWidth, ciButtonHeight);
  end;
  ALeft := Width - ciButtonWidth  - 9;
  if FButtonControls[bkCancel].Visible then
  begin
    FButtonControls[bkCancel].SetBounds(ALeft, ATop, ciButtonWidth, ciButtonHeight);
    Dec(ALeft, ciButtonWidth + 11);
  end;
  if FButtonControls[bkNext].Visible or FButtonControls[bkFinish].Visible then
  begin
    FButtonControls[bkNext].SetBounds(ALeft, ATop, ciButtonWidth, ciButtonHeight);
    // !!! YW - FinishButton's bounds should be same as the next button
    FButtonControls[bkFinish].SetBounds(ALeft, ATop, ciButtonWidth, ciButtonHeight);
    Dec(ALeft, ciButtonWidth + 1);
  end;
  if FButtonControls[bkBack].Visible then
  begin
    FButtonControls[bkBack].SetBounds(ALeft, ATop, ciButtonWidth, ciButtonHeight);
  end;
end;

procedure TKWizard.UpdateButtonControlsStatus;
begin
  // YW - Here we must use actual FButtonControls := .... instead of
  // FWizardButtons := ..., because the visible property of FWizardButtons
  // is not the same as the one in FButtonControls
  FButtonControls[bkStart].Enabled := (csDesigning in ComponentState) or
                                      (not IsFirstPage(FActivePage));
  FButtonControls[bkLast].Enabled := (csDesigning in ComponentState) or
                                      IsLastPage(FActivePage);
  FButtonControls[bkBack].Enabled := (csDesigning in ComponentState) or
                                     (not IsFirstPage(FActivePage));
  FButtonControls[bkNext].Visible := (csDesigning in ComponentState) or
                                     (FWizardButtons[bkNext].Visible and //!!!
                                      not IsLastPage(FActivePage));
  FButtonControls[bkFinish].Visible := FWizardButtons[bkFinish].Visible and //!!!
                                       IsLastPage(FActivePage);
end;

procedure TKWizard.GetChildren(Proc: TGetChildProc; Root: TComponent);
var
  I: Integer;
  Control: TControl;
begin
  // YW - Force the wizard to load its pages in page order.
  for i := 0 to FPages.Count - 1 do
  begin
    Proc(TComponent(FPages[i]));
  end;
  // YW - Load other controls, otherwise, those controls won't show up in
  // the wizard.
  for I := 0 to ControlCount - 1 do
  begin
    Control := Controls[I];
    // YW - Because all the pages are already loaded, so here we do NOT need to
    // load them again, otherwise it will cause duplicate component name
    // problem.
    if not (Control is TKWizardCustomPage) and (Control.Owner = Root) then
    begin
      Proc(Control);
    end;
  end;
end;

procedure TKWizard.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited;
  if (Operation = opRemove) and (AComponent = FHeaderImages) then
  begin
    SetHeaderImages(nil);
  end;
end;

procedure TKWizard.ImageListChange;
begin
  if HandleAllocated and (Sender = FHeaderImages) and Assigned(FActivePage) then
  begin
    FActivePage.Invalidate;
  end;
end;

procedure TKWizard.ShowControl(AControl: TControl);
begin
  if (AControl is TKWizardCustomPage) and
     (TKWizardCustomPage(AControl).Wizard = Self) then
    SetActivePage(TKWizardCustomPage(AControl));
  inherited ShowControl(AControl);
end;

procedure TKWizard.Resize;
begin
  inherited;
  RepositionButtons;
end;

end.
